/***************************************************************************
 *   Copyright (C) 2004 by Byoungyoung, La                                 *
 *   la9527@yahoo.co.kr                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "exception.h"

using namespace MLS;

Exception::
Exception(char*	pMsg)
{
	if(pMsg)
	{
		m_strError		+= pMsg;
		m_sExcepInfo	+= pMsg;
	}
}

Exception::
Exception(const string&	pMsg)
{
	if(pMsg == "")
	{
		m_strError		+= pMsg;
		m_sExcepInfo	+= pMsg;
	}
}

Exception::
Exception(const char* file, int lineno, string	pMsg)
{
	m_strError = "";
	if(pMsg != "")
		m_strError	+= pMsg;

 	char 	cLinenoTmp[30];
	memset(&cLinenoTmp, 0, sizeof(cLinenoTmp));
	sprintf(cLinenoTmp, "%s", file);

	m_sExcepInfo = "";
	m_sExcepInfo = m_sExcepInfo + "(" + cLinenoTmp;

	memset(&cLinenoTmp, 0, sizeof(cLinenoTmp));
	sprintf(cLinenoTmp, "%d", lineno);

	m_sExcepInfo = m_sExcepInfo + ", " + cLinenoTmp;
	m_sExcepInfo = m_sExcepInfo + ") *" + pMsg;
	//cout << m_sExcepInfo << endl;
}

Exception::
Exception(const char *file, int lineno, const char *fmt, ...)
{
	char		buffer[4096];
	int 		buflen = 0;
	va_list 	ap;

	if (strlen(fmt) < sizeof(buffer))
	{
		buflen = sprintf(buffer, "- (%s,%03d) *", file, lineno);

		va_start(ap, fmt);
		vsprintf(buffer+buflen, fmt, ap);
		va_end(ap);

		m_strError = "";
		m_strError	= m_strError + buffer;
	}
	else
	{
		cout << "Exception Error :: Beffer Over Flow :: " << endl;
	}
}

Exception::
~Exception()
{
}

ostream&
operator>>(ostream& output, Exception& tEx)
{
	return output << (char*)tEx;
}

char*
Exception::
GetInfo(void)
{
	return (char*)m_sExcepInfo.c_str();
}

