#ifndef file_h_
#define file_h_

#include "define.h"
#include "drawutil.h"

namespace MLS {
	
class File
{	
	public:
		// 화면에 보여줄 name 
		std::string name;
		
		// FullName
		std::string FullName;
		
		char date[9];
		char time[6];
		char attr[11]; // drwxrwxrwx
		uint size;
		bool selected;
		
		time_t mtime;
		
		color_entry *color;
		
		bool bDir;
		
		std::string ext()
		{
			std::string::size_type p= name.rfind(".");
			if (p == std::string::npos || p==0) 
				return "";
			return name.substr(p+1);		
		}
		
		File()
		{
			memset(&date, 0, sizeof(date));
			memset(&time, 0, sizeof(time));
			memset(&attr, 0, sizeof(attr));
		}
		
		void clear(void)
		{
			memset(&date, 0, sizeof(date));
			memset(&time, 0, sizeof(time));
			memset(&attr, 0, sizeof(attr));
			size = 0;
			selected = false;
			mtime = 0;
			color = NULL;
			bDir = false;
		}
};

}; // namespace

#endif 
