#ifndef StringTokenizer_h_
#define StringTokenizer_h_

#include <string>

namespace MLS {

class StringTokenizer
{
protected:
	std::string _str;
	std::string _delim;

	std::string _token;

	std::string::size_type _cur;

public:
	StringTokenizer();
	StringTokenizer(const std::string &p, const std::string &d = "\r\n ");
	~StringTokenizer();

	void SetString(const std::string &p) {_str = p; _cur = 0; }
	void SetDelim (const std::string &p) {_delim = p;}

	bool Next();
	const std::string &Get() {return _token;}
	const std::string Rest() {return _str.substr(_cur);}

//	bool operator ==(const std::string &p) { return _token == p ;}
//	operator std::string &() {return _token;}

//	friend bool operator==(const std::string &p1, StringTokenizer &p2);
};

//bool operator==(const std::string &p1, StringTokenizer &p2)
//{
//	return p1 == p2._token;
//}

}; // namespace

#endif

