#ifndef __CONFIG_H__
#define __CONFIG_H__

#include <vector>
#include <list>
#include <string>
#include <map>

#include "drawutil.h"
#include "action.h"

namespace MLS {
	
// config
class Config
{
public:
	std::list<std::string> filter; // 필터
	std::string date_type, extern_viewer, extern_editor;
	std::string home, cfghome, mcdroot;
	std::string colorset;
		
	// color
	color_entry MCD, MCDstat, Dir, Drive, Line, FuncN, FuncA, StatN, StatA, Else, Help, Quick, QuickMCD, Dialog;
	
	std::map<std::string, color_entry> name_col;
	std::map<std::string, color_entry> ext_col;	
	std::map<int, color_entry> mask_col;
	
	std::map<std::string, Action> ext_prog;

	Action Func[12];  // F1~F12
	Action aFunc[12]; // F1~F12
	Action cFunc[12]; // F1~F12
	
	// toggle
	bool ShowHidden;	// .으로 시작하는 파일 보이기..
	bool AutoDrawmode;  // 그리기 방식을 자동으로 선택.
	bool FixedRow;      // 고정된 세로줄
	bool DirSort;		// DirSort
	bool McdSort;		// McdSort

	int sort;           // 정렬방식
	int column;      // 그리기 방식(컬럼수)

	Config();				
	~Config();

	void set_default();
	int  load(const char *);
	int  load_colorset(const char *);
};

extern Config conf;

}; // namespace

#endif
