#ifndef dirreader_h_
#define dirreader_h_

#include <dirent.h>
#include <sys/stat.h>
#include <unistd.h>

#include <string>

#include "file.h"
#include "reader.h"

namespace MLS {

class DirReader : public Reader
{
protected:
	DIR         *m_handle;
	dirent      *m_pEntry;
	struct stat  m_statbuf;
	
	std::string  m_path;
	char *m_lpath;
	
public:
	DirReader();
	
	virtual bool Init(const std::string &path);
	virtual bool Next();
	virtual bool GetInfo(File &);
	virtual void Destroy();
	virtual bool isRoot();
	
	// Sync  
	virtual int  Copy(vector<string>& tCpyData, string& sTarget) { return ERROR; }
	virtual int  Remove(vector<string>& tRemoveData) { return ERROR; }
};

};

#endif
