#include <ncurses.h>
#include "mlslocale.h"
#include "panel.h"

using namespace MLS;

static char *help;

int MLS::Panel::about()
{
	int width = 40;
	int height = 11;
	
	width +=4;
			
	WINDOW *win = newwin(height, width, (LINES-height)/2, (COLS-width)/2);
	wclear(win);
	wbkgd(win, COLOR(COLOR_WHITE, 3));
	
	wattron(win ,A_BOLD);
	box(win, VLINE, HLINE);
	
	wattroff(win, A_BOLD);
	
	// title 출력
	wattron(win, COLOR(COLOR_BLACK, COLOR_WHITE));
	wmove(win, 1, 1);
	whline(win, ' ', width-2);
	mvwprintw(win, 1, 1, "About Mls");
	wattroff(win, A_BOLD);
	
	// msg
	wattron (win, COLOR(COLOR_WHITE, 3));
	wattron (win, A_BOLD);
	mvwprintw(win, 3, 1, "Mls %s - User-Interfaced File Manager ", "v0.1");
	mvwprintw(win, 5, 1, "Author : ");
	mvwprintw(win, 6, 1, " IOKLO (leesjung@nownuri.net)");
	mvwprintw(win, 7, 1, " Byoungyoung, La (la9527@yahoo.co.kr)");
	mvwprintw(win, 9, 1, "(c) 2004 The Mls Developers");	
	
	wattroff(win, A_BOLD);
	
	wrefresh(win);
	
	getch();	
	delwin(win);		
	return 1;	
}

int MLS::Panel::cmd_help()
{	
	int width = 40;
	int height = 11;
	
	width +=4;
			
	WINDOW *win = newwin(height, width, (LINES-height)/2, (COLS-width)/2);
	wclear(win);
	wbkgd(win, COLOR(COLOR_WHITE, 3));
	
	wattron(win ,A_BOLD);
	box(win, VLINE, HLINE);
	
	wattroff(win, A_BOLD);
	
	// title 출력
	wattron(win, COLOR(COLOR_BLACK, COLOR_WHITE));
	wmove(win, 1, 1);
	whline(win, ' ', width-2);
	mvwprintw(win, 1, 1, "Help");
	wattroff(win, A_BOLD);
	
	// msg
	wattron (win, COLOR(COLOR_WHITE, 3));
	wattron (win, A_BOLD);
	mvwprintw(win, 3, 1, "alt-c : copy");
	mvwprintw(win, 4, 1, "alt-x : exit");
	mvwprintw(win, 5, 1, "f12   : menu");
	
	
	wattroff(win, A_BOLD);
	
	wrefresh(win);
	
	getch();	
	delwin(win);		
	return 1;	
}
