#include "history.h"

using namespace MLS;
using namespace std;

static string null;

History::History()
{
	m_cur = -1;
	bAdd  = true;
}
//             c   
// 0 1 2 3 4 5 6 7 8 
// a b c d e f g h

void History::AddEntry(const string &path)
{
	if (!bAdd)
	{
		bAdd = true;
		return;
	}
	m_cur++;
	
	if (m_paths.size() > m_cur)
		m_paths.erase(m_paths.begin()+m_cur, m_paths.end());
	
	m_paths.push_back(path);	
}

const string &History::GetPrev()
{
	if (m_cur == -1) return null;
	if (!isFront()) m_cur--;	
	
	bAdd = false;
	
	return m_paths[m_cur];
}

const string &History::GetNext()
{
	if (m_cur==-1) return null;
	if (!isBack()) m_cur++;
	
	bAdd = false;
	
	return m_paths[m_cur];
}

bool History::isFront()
{
	return (m_cur == 0);
}

bool History::isBack()
{
	return (m_cur == m_paths.size()-1);
}
