#ifndef mpool_h_
#define mpool_h_

#include <vector>
#include "mls.h"

template<typename T>
class MemoryPool
{
protected:
	std::vector<T*> m_data;
	typedef typename std::vector<T*>::iterator Itor;
	unsigned int m_nData;
	
	void Destroy() 
	{
		for (Itor i = m_data.begin(); i != m_data.end(); ++i)
		{
			delete *i;			
		}
		m_data.clear();
	}
	
public:
	MemoryPool()  { m_nData = 0; }
	~MemoryPool() { Destroy();}
	
	T& Get()
	{
		m_nData++;
		
		if (m_data.size() < m_nData)
		{
			m_data.push_back(new T);			
			return *m_data.back();
		}
		else 
		{
			return *m_data[m_nData-1];			
		}	
	}
	
	void Clear() { m_nData = 0; }	
};

#endif
