#include <sstream>
#include <iomanip>
#include <math.h>
#include <ctype.h>

#include "strutil.h"

using namespace std;

string strutil::tolower(const string &p)
{
	string r;
	for(string::const_iterator i = p.begin(); i!=p.end(); i++)
	{
		if ('A' <= *i && *i <= 'Z') r += *i-'A'+'a';	
		else r += *i;
	}
	return r;
}

string strutil::chop(const string &p)
{
	string::size_type f = p.find_first_not_of(" \n\r");
	string::size_type r = p.find_last_not_of(" \n\r");
	
	if (f == string::npos || r== string::npos) return "";
	
	return p.substr(f, r-f+1);
}

string strutil::getbetween(const string &p, const char f, const char r)
{
	string::size_type s = p.find_first_of(f);
	if (s == string::npos) return "";
	string::size_type s2 = p.find_first_of(r, s+1);
	if (s2 == string::npos) return "";	
	
	return p.substr(s+1 , s2-s-1);	
}

string strutil::replace(const string &p, const char*find, const char*replace)
{
	//  01234567890123456789012
	// "the great great bassist" "great" "brother"	
	string arg;
	
	string::size_type t = 0;
	string::size_type t2= p.find(find);
	
	string::size_type len = strlen(find);
	
	while(t2 != string::npos)
	{
		arg += p.substr(t, t2-t);
		arg += replace;
		
		t = t2 + len;
		t2 = p.find(find, t);
	}
	
	arg += p.substr(t);
	
	return arg;
}

string strutil::toregular(unsigned int number)
{
	unsigned int n=1, p=1;
	string str;	
	str.reserve(10);
			
	while(number/10 >= p) {p*=10; n+=1;}		
	
	while (n)
	{
		str += '0' + number / p;
		
		number %= p;
		p /= 10;
		n--;
		
		if (n!=0 && n%3==0) str += ',';	
	}
	
	return str;
}
